;____________________CREATE THE NOTIFY SETTINGS AND / OR LAYOUT__________________;
; Creates the notify and configs it.
;________________________________________________________________________________;

alias ctnotify {
  if (- isin $1) {
    var %prop = $remove($1,-)
    var %props = nmtclohisd
    var %name = $2

    if (!$hget(notify)) { hmake notify 1000 }

    ;ERROR 1: TOO MANY PARAMETER
    if ($len(%prop) > 1 || !$len(%prop)) { var %error =  * /ctnotify: insufficient parameter } 
    ;ERROR 2: UNKNOWN PARAMETER
    elseif (%prop !isin %props) { var %error =  * /ctnotify: unknown parameter }
    ;ERROR 3: UNKNOWN NOTIFY
    elseif ($1 != -n && !$hget(notify,%name $+ status)) { var %error = * /ctnotify: %name not found }
    ;ERROR 4: TOO MANY / LESS COLORS
    elseif ($1 == -c && $0 != 7) { var %error = * /ctnotify: $iif($0 > 7,too many arguments,arguments missing) }
    ;ERROR 5: ICON NOT ALLOWED
    elseif ($1 == -i && *.ico iswm $3- && $3 != +s) { var %error = * /ctnotify: wrong image format }

    if (%error) { goto error }

    elseif (%prop == n) {
      if (!$hget(notify,%name $+ status)) { 
        hinc notify total
        hadd notify $hget(notify,total) %name    
        hadd notify %name $+ bg 255,255,255
        hadd notify %name $+ tb 255,255,255
        hadd notify %name $+ bd 0,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0   
        hadd notify %name $+ time 0
      }
      hadd notify %name $+ status closed 
    }

    elseif (%prop == c) {
      hadd notify %name $+ bg $3
      hadd notify %name $+ tb $4
      hadd notify %name $+ bd $5
      hadd notify %name $+ hd $6
      hadd notify %name $+ tx $7
    }
    elseif (%prop == i) {
      if ($3 == +s) { 
        hadd notify %name $+ smallicon 1
        hadd notify %name $+ icon $4-
      }
      else { hadd notify %name $+ icon $3- }
    }
    elseif (%prop == h) {
      hadd notify %name $+ head $3-
    }
    elseif (%prop == s) {
      hadd notify %name $+ text $3-
    }
    elseif (%prop == o) {
      hadd notify %name $+ time $3
      if (d isin $4) { hadd notify %name $+ delete 1 }
      if (t isin $4) { hadd notify %name $+ stamp 1 }
      if (f isin $4) { hadd notify %name $+ style 1 }
      if (l isin $4) { hadd notify %name $+ left 1 }
      if (r isin $4) { hadd notify %name $+ right 1 }
    }
    elseif (%prop == d) {
      ctnotify_delete %name
    }
    elseif (%prop == m) {
      hadd notify %name $+ memory $3-
    }
    elseif (%prop == t) {
      if ($3 == StandardGreen) {
        hadd notify %name $+ bg 255,255,255
        hadd notify %name $+ tb 46,156,0
        hadd notify %name $+ bd 0,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0
      }
      elseif ($3 == StandardBlue) {   
        hadd notify %name $+ bg 255,255,255
        hadd notify %name $+ tb 95,152,255
        hadd notify %name $+ bd 0,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0
      }    
      elseif ($3 == LightRed) {   
        hadd notify %name $+ bg 255,140,140
        hadd notify %name $+ tb 255,140,140
        hadd notify %name $+ bd 200,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0
      } 
      elseif ($3 == LightYellow) {   
        hadd notify %name $+ bg 255,249,194
        hadd notify %name $+ tb 255,249,194
        hadd notify %name $+ bd 0,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0
      }      
      else { 
        hadd notify %name $+ bg 255,255,255
        hadd notify %name $+ tb 255,255,255
        hadd notify %name $+ bd 0,0,0
        hadd notify %name $+ hd 0,0,0
        hadd notify %name $+ tx 0,0,0  
      }        
    }
    elseif (%prop == l) { 
      hadd notify %name $+ trans $3
    }    
  }
  else {
    ctnotify_create $1
  }
  :error
  if (%error) {
    echo -ac info %error
    return
  }
}

alias -l ctnotify_create {

  ;ERROR 1: NOTIFY OPEN
  if ($window(@notify $+ $1)) { var %error * /ctnotify: $1 already open }
  ;ERROR 2: DOESN'T EXIST
  if (!$hget(notify,$1 $+ status)) { var %error * /ctnotify: $1 doesn't exist }

  if (%error) { goto error }

  else {
    var %name = $1
    var %window = @notify $+ %name

    hinc notify open
    hadd notify %name $+ status open

    var %cbg = $hget(notify,%name $+ bg)
    var %ctb = $hget(notify,%name $+ tb)
    var %cbd = $hget(notify,%name $+ bd)
    var %chd = $hget(notify,%name $+ hd)
    var %ctx = $hget(notify,%name $+ tx)
    var %notifycount = $hget(notify,open)

    if (%cbg && %ctb && %cbd && %chd && ctx) {
      var %x = $calc($res(x) - 300)
      var %y = $calc($res(y) - $calc(100 * %notifycount))  

      var %icon = $hget(notify,%name $+ icon)
      var %head = $hget(notify,%name $+ head)
      var %text = $hget(notify,%name $+ text)
      var %time = $hget(notify,%name $+ time)
      var %style = $hget(notify,%name $+ style)
      var %smicon = $hget(notify,%name $+ smallicon)
      var %stamp = $hget(notify,%name $+ stamp)

      var %active = $active
      window -pdoaBk0w0 +dL %window %x %y 300 100
      window -a " $+ %active $+ "

      ; DRAW BACKGROUND
      var %c1 = $gettok(%cbg,1,44), %c2 = $gettok(%cbg,2,44), %c3 = $gettok(%cbg,3,44)  
      drawrect -rf %window $rgb(%c1,%c2,%c3) 1 0 0 300 100

      ; DRAW TITLE
      if (%head) { 
        var %c12 = $gettok(%ctb,1,44), %c22 = $gettok(%ctb,2,44), %c32 = $gettok(%ctb,3,44)
        if (!%style) {
          drawgradient -r %window $rgb(%c12,%c22,%c32) $rgb(255,255,255) 2 2 296 10
          drawgradient -r %window $rgb(255,255,255) $rgb(%c12,%c22,%c32) 13 2 296 10
        }
        else {
          drawrect -rf %window $rgb(%c12,%c22,%c32) 1 2 2 296 22
        }
      }

      ; DRAW BORDER
      var %c1 = $gettok(%cbd,1,44), %c2 = $gettok(%cbd,2,44), %c3 = $gettok(%cbd,3,44)
      drawrect -r %window $rgb(%c1,%c2,%c3) 2 0 0 300 100
      if (%head) { drawline -r %window $rgb(%c1,%c2,%c3) 1 0 24 300 24 }

      ; DRAW ICON
      if (%icon && $exists(%icon) && !%smicon) { 
        var %y1 = $calc(($iif(%head,80,100) - $pic(%icon).height) / 2 $iif(%head, + 20))
        drawpic %window 10 %y1 %icon 
      }
      elseif (%icon && $exists(%icon) && %smicon && %head) { 
        var %y1 = $calc(($iif(%head,80,100) - $pic(%icon).height) / 2 $iif(%head, + 20))
        drawpic -s %window 5 5 16 16 %icon 
      }

      ; DRAW HEAD
      if (%head) {  
        var %c1 = $gettok(%chd,1,44), %c2 = $gettok(%chd,2,44), %c3 = $gettok(%chd,3,44)
        drawtext -opr %window $rgb(%c1,%c2,%c3) Arial 12 $iif(%smicon,24,8) 5 %head 
        if (%stamp) { 
          drawtext -r %window $rgb(%c1,%c2,%c3) Arial 12 $calc(295 - $width($time,Arial,12)) 5 $time
        } 
      }


      ; DRAW TEXT

      if (%text) {
        if (%icon) { 
          var %wid = 206
          var %sta =  $calc($pic(%icon).width + 20)
        }
        else { 
          var %wid = 266 
          var %sta = 14
        }

        var %sta.y = $iif(%head,26,10)
        var %c = $hget(notify,%name $+ tx)
        var %c1 = $gettok(%ctx,1,44), %c2 = $gettok(%ctx,2,44), %c3 = $gettok(%ctx,3,44)
        var %i = 1
        var %j = 1

        while (%j <= $numtok(%text,13)) {
          var %text2 = $gettok(%text,%j,13)
          var %i = 1
          while (%i <= $wrap(%text2, Arial, 12 , %wid, 0)) {
            drawtext -pr %window $rgb(%c1,%c2,%c3) Arial 12  %sta $calc(%sta.y + %i * 12 - 12 + $iif(%j > 1,12,0)) $wrap(%text2, Arial, 12 , %wid, %i)
            inc %i
          }
          inc %j
          inc %sta.y 12
        }
      }

      ; FADE NOTIFY
      fade -i %window 5 $iif($hget(notify,%name $+ trans),$v1,255)

      ; DELETION TIMER
      if (%time) { .timer $+ %name 1 %time ctnotify_delete %name }
    }
  }
  :error
  if (%error) {
    echo -ac info %error
    return
  }
}

alias -l ctnotify_delete {
  var %name = $1

  if ($hget(notify, %name $+ delete)) {
    hdel notify %name $+ status
    hdel notify %name $+ bg
    hdel notify %name $+ tb
    hdel notify %name $+ hd
    hdel notify %name $+ tx
    hdel notify %name $+ bd

    hdel notify %name $+ status
    hdel notify %name $+ icon
    hdel notify %name $+ head
    hdel notify %name $+ text
    hdel notify %name $+ time
    hdel notify %name $+ delete
    hdel notify %name $+ stamp
    hdel notify %name $+ style
    hdel notify %name $+ left
    hdel notify %name $+ right
    hdel notify %name $+ trans
    hdel notify %name $+ memory

    var %id1 = $hfind(notify, %name, 1).data
    hdel notify %id1
    var %id = $calc(%id1 + 1)

    while (%id <= $hget(notify,total)) {
      hadd notify $calc(%id - 1) $hget(notify,%id)
      inc %id
    }

    hdel notify %id

    hdec notify total
  }

  if ($window(@notify $+ %name)) { 
    fade -oc @notify $+ %name 5 $iif($hget(notify,%name $+ trans),$v1,255) 
    hdec notify open 
    if ($hget(notify, %name $+ delete)) { hadd notify %name $+ status closed }
  }

  if ($timer(%name)) { .timer $+ %name off }
}

;________________________________________________________________________________;


alias ctget {
  if ($isid) {
    if ($1 == 0) {
      if ($prop == open) { return $hget(notify,open) }
      else { return $hget(notify,total) }
    }

    elseif ($1 > 0 && $1 isnum) {
      var %name = $hget(notify,$1)
    }

    elseif ($1 isalnum) {
      var %name = $1
    }

    if (%name) {
      if (!$prop) { return %name }
      elseif ($prop == text) { return $iif($hget(notify,%name $+ text),$v1,$false) }
      elseif ($prop == open) { return $iif($hget(notify,%name $+ status) == open,$true,$false) }
      elseif ($prop == head) { return $iif($hget(notify,%name $+ head),$v1,$false) }
      elseif ($prop == data) { return $iif($hget(notify,%name $+ memory),$v1,$false) }
      elseif ($prop == time) { return $iif($hget(notify,%name $+ time),$v1,0) }
      elseif ($prop == l) { return $iif($hget(notify,%name $+ left),$true,$false) }
      elseif ($prop == r) { return $iif($hget(notify,%name $+ right),$true,$false) }
    }
  }
}

;____________________SIGNALS THAT FIRE WHEN NOTIFY IS CLICKED____________________;


menu @notify* {
  sclick: .signal notify $remove($active,@notify) $mouse.x $mouse.y left $hget(notify,$remove($active,@notify) $+ memory)
  rclick: .signal notify $remove($active,@notify) $mouse.x $mouse.y right  $hget(notify,$remove($active,@notify) $+ memory)
}
;________________________________________________________________________________;

;____________________ON CLICK CLOSE______________________________________________;

on *:signal:notify: {
  ;CLOSE IF +r IS SET
  if ($4 == left && $hget(notify,$1 $+ left)) { ctnotify -d $1 }

  ;CLOSE IF +l IS SET
  elseif ($4 == right && $hget(notify,$1 $+ right)) { ctnotify -d $1 }
}  
;________________________________________________________________________________;

;____________________FADE A WINDOW IN OR OUT_____________________________________;
; Fades a window in or out by setting the transparency up or down
;
; Usage: 
; fade -i <@name> <speed> fades the window in
; fade -o <@name> <speed> fades the window out
; fade -oc <@name> <speed> fades the window out and closes it
;________________________________________________________________________________;
alias fade {

  var %name = $2
  var %speed = $3
  var %end = $iif($4,$4,255)

  if ($1 == -i) {
    var %i = 1
    while (%i <= %end) {
      setlayer %i %name
      inc %i %speed
    }
  }
  elseif (o isin $1) {
    var %i = %end
    while (%i >= 0) {
      setlayer %i %name
      dec %i %speed
    }
    if (c isin $1) { window -c %name }
  }
}  
;________________________________________________________________________________;

alias res {
  if ($isid) {
    if ($prop == mirc) {
      if ($1 == x) { return $window(-3).w }
      elseif ($1 == y) { return $window(-3).h }
    }
    else {
      window -hdw0 @resolution 0 0 10000 10000
      var %h = $window(@resolution).h
      window -c @resolution
      if ($1 == x) { return $window(-1).w }
      elseif ($1 == y) { return %h }

    }
  }
}
;________________________________________________________________________________;



;/DRAWGRADIENT
;---------------------------------------------------------------------------
;  Usage: /drawgradient [-nrh] <@window> <color1> <color2> <x y w h>
;
;  Draws a gradient from color1 to color2 in the specified rectangle
;   If switch h is set, the gradient will be horizontal, else it will
;   be vertical.
;   Set r if the colors are rbg-values.
;   Set n to prevend the command from drawing it immidiatly.
;---------------------------------------------------------------------------

alias drawgradient {
  if (-* iswm $1) {    
    if (h isin $1) { var %paramH 1 }
    if (r isin $1) { var %paramR 1 }
    if (n isin $1) { var %paramN 1 } 
    var %window = $2, %x = $5, %y = $6, %w = $7, %h = $8  
    var %rgb1 = $iif(%paramR,$rgb($eval($3)),$rgb($color($3)))
    var %rgb2 = $iif(%paramR,$rgb($eval($4)),$rgb($color($4)))
  }
  else {
    var %window = $1, %rgb1 = $rgb($color($2)), %rgb2 = $rgb($color($3)), %x = $4, %y = $5, %w = $6, %h = $7
  }

  if (!$window(%window)) { echo -ces * /drawgradient: invalid window | return }
  if ($0 < 7) { echo -ecs * /drawgradient: nsufficient parameters | return }

  var %r = $gettok(%rgb1,1,44), %g = $gettok(%rgb1,2,44), %b = $gettok(%rgb1,3,44)
  var %r2 = $calc($gettok(%rgb2,1,44) - %r)
  var %g2 = $calc($gettok(%rgb2,2,44) - %g) 
  var %b2 = $calc($gettok(%rgb2,3,44) - %b)

  var %c = $iif(%paramH,%w,%h)

  var %incR = $calc(%r2 / %c), %incG = $calc(%g2 / %c), %incB = $calc(%b2 / %c)
  var %i = $iif(%paramH,%y,%x)
  var %wpos = $iif(%paramH,1,%w)
  var %hpos = $iif(%paramH,%h,1)

  while (%i <= $calc($iif(%paramH,%y,%x) + %c)) {

    drawrect -rn %window $rgb(%r,%g,%b) 1 $iif(%paramH,%i,%y) $iif(%paramH,%x,%i) %wpos %hpos

    inc %r %incR
    inc %g %incG
    inc %b %incB
    inc %i
  }
  if (!%paramN) { drawdot %window }
}

alias test {
  var %reg = (http://[^/ ]*(?:/[^/ ]*)*)
  var %r = $regex(url,test asdf http://www.google.de hgallo,%reg)
  echo -a $regml(url,1).pos %r
} 
